/*
 *
 * Copyright (C) 2003 Sadysta ( http://sadysta.ath.cx )
 *
 * This file is part of Free GG.
 *
 * Free GG is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Free GG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Free GG; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

//---------------------------------------------------------------------------

#ifndef TransferThreadH
#define TransferThreadH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------
enum TransferType
{
        TT_PASSIVE_GET_FILE,
        TT_PASSIVE_SEND_FILE,
        TT_ACTIVE_GET_FILE,
        TT_ACTIVE_SEND_FILE
};

class TTransferThread : public TThread
{
private:
protected:
        void __fastcall Execute();
public:
        __fastcall TTransferThread(bool CreateSuspended);

        void __fastcall _Log();
        void __fastcall Log (AnsiString s);
        void __fastcall _Progress();
        void Progress (AnsiString FileName, long transferred, long size, int img_index);
        void SendFile (AnsiString FileName, int socket);

        int client_sock;
        AnsiString _log_msg;
        TransferType type;
        short d_port;
        AnsiString d_addr;
        int d_uin;

        AnsiString _file_name;
        long _transferred, _size;
        int _img_index;

        TListItem *I;
};
//---------------------------------------------------------------------------
#define GG_DCC_CATCH_FILE       0x0002
#define GG_DCC_WANT_FILE        0x0003
#define GG_DCC_HAVE_FILE        0x0001
#define GG_DCC_HAVE_FILEINFO    0x0003
#define GG_DCC_GIMME_FILE       0x0006
#define GG_DCC_FILEHEADER       0x0003
#define GG_DCC_LAST_FILEHEADER  0x0002

struct file_info_struct {
       	int mode;                  /* dwFileAttributes */
       	int ctime[2];              /* ftCreationTime */
       	int atime[2];              /* ftLastAccessTime */
       	int mtime[2];              /* ftLastWriteTime */
	int size_hdw;              /* grne 4 bajty dugoci pliku */
	int size_ldw;              /* dolne 4 bajty dugoci pliku */
	int reserved1;             /* 0 */
	int reserved2;             /* 0 */
	char file_name[276];       /* tablica zaczynajca si od nazwy pliku, wypeniona zerami */
};

struct file_accept {
	int type;      /* 0x0006 GG_DCC_GIMME_FILE */
	int start;     /* od ktrej pozycji zacz przesyanie */
	int dunno;     /* 0 */
};

struct file_header {
	int type;       /* GG_DCC_*_FILEHEADER */
	int chunk_size; /* rozmiar paczki */
	int dunno;      /* 0 */
};
//---------------------------------------------------------------------------
#endif
